SUBROUTINE GFEXFO(IWA,RWA,DWA,IPDMS,&
        IINFO,RINFO,NPCUR,CURCOR,CURVEL,&
        KXFO,RXFO,RHXFO,&  
        IXFO,IEXTF,ICOORD,NINT,NREA,NSTO,NSTR,&
        CHEXT,STATE,GAMMA,VELLOT,STOR,IERR)
    !DEC$ ATTRIBUTES DLLEXPORT, ALIAS :"gfexfo_"::GFEXFO 
    !DEC$ ATTRIBUTES STDCALL::   GFEXFO
    !DEC$ ATTRIBUTES REFERENCE:: IWA,RWA,DWA,IPDMS 
    !DEC$ ATTRIBUTES REFERENCE:: IINFO,RINFO,NPCUR,CURCOR,CURVEL 
    !DEC$ ATTRIBUTES REFERENCE:: KXFO,RXFO,RHXFO 
    !DEC$ ATTRIBUTES REFERENCE:: IXFO,IEXTF,ICOORD,NINT,NREA,NSTO,NSTR
    !DEC$ ATTRIBUTES REFERENCE:: CHEXT,STATE,GAMMA,VELLOT,STOR,IERR
    IMPLICIT NONE
    !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    ! - Internal variables
    !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    INTEGER IERR        !internal error flag code,  -- <0 error detected; =0 no error; >0 warning
    INTEGER LAB         !?
    !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    ! - External variables
    !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    INTEGER, INTENT(IN):: IWA(*),IPDMS(*),ICOORD! internal work *array*; 
                                                        ! pointers to work *array*; 
                                                        ! flag for type of coordinate system for external force: 0 global coord; 1 local coord
    INTEGER, INTENT(IN):: IINFO(*),NPCUR,KXFO(*),IXFO,NINT,NREA,NSTO,NSTR  
    ! integer information *array(12)*
    ! Number of points where current velocities are given
    ! integer external force parameter *array*
    ! external force number
    ! number of integer parameters
    ! number of real parameters
    ! number of parameters for intermediate storage
    ! number of input strings
    REAL, INTENT(IN)   :: RWA(*),RINFO(*),CURCOR(3,*),CURVEL(3,*)
    ! real work *array*
    ! real information *array(6)*
    ! coordinates *array* of NPCUR points
    ! current velocity *array* for NPCUR points
    REAL               :: RXFO(*),RHXFO(NSTO)   ! real external force parameters
                                                ! array of intermediate storage
    DOUBLE PRECISION, INTENT(IN):: STATE(12,*),GAMMA(9,*),VELLOT(6,*)
    ! state variables (positions and velocities),
    ! coordinate transformation matrix
    ! local total velocity
    REAL, INTENT(OUT)  :: STOR(*)   ! array of storage on file, 9 variables
    DOUBLE PRECISION DWA(*)         ! double precision work array
    CHARACTER*120 CHEXT(MAX(NSTR,1))! NSTR character strings as input
    CHARACTER(*), PARAMETER :: fileplace = 'H:\thesis\'
    INTEGER ISTEP, IBODY, NBDY, NDIM, NSTEP, ITER, IEXTRA, NEXTRA,IEXTF,MODUL
    REAL  TIME,DT,GRAV,RHOW,RHOA
    ! %%%%%%  variable for structure, position, velocity  %%%%%%
    DOUBLE PRECISION XG,YG,ZG,VX,VY,VZ
    ! %%%%  variable for environment, current,wave velocity %%%%
    DOUBLE PRECISION VCX,VCY,VCZ,VWX,VWZ,ZETA0,T,OMEGA,K,UWAVESUBS(9,12),WWAVESUBS(9,12),UWAVESUBB(2,12),WWAVESUBB(2,12)
    ! %%%%%%%%%%%%%%%%  variable for net panel  %%%%%%%%%%%%%%%%
    DOUBLE PRECISION SPNVL(3,12),SPNVG(3,12),BPNVL(3,12),BPNVG(3,12),RMV(3),SN,A(2),AS1,AB1(2),SNPBL(3,2,12),SNPSL(3,9,12),SNPBG(3,2,12),SNPSG(3,9,12),X,Y,Z
    INTEGER AS,AB
    ! %%%%%%%%  variable for relative motion and force  %%%%%%%%    
    DOUBLE PRECISION COSTHETAS(9,12),CDS(9,12),COSTHETAB(2,12),CDB(2,12),FDS(9,12),FDB(2,12),FDSX(9,12),FDBX(2,12),FDSY(9,12),FDBY(2,12),FDSZ(9,12),FDBZ(2,12),MS(3,9,12),MB(3,2,12)
    INTEGER I,J
    DOUBLE PRECISION TI, PI
    PI = 3.1415926
    !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    ! - elements in IINFO
    !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    MODUL   = IINFO(2);   ! Module
    IBODY   = IINFO(3);   ! body number
    ISTEP   = IINFO(6);   ! step number
    NSTEP   = IINFO(7);   ! number of steps
    IEXTRA  = IINFO(8);   ! substep number
    NEXTRA  = IINFO(9);   ! number of substeps
    ITER    = IINFO(12);  ! iteration no. in current step
    !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    ! - elements in RINFO
    !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%  
    TIME = RINFO(1); ! actual total time
    DT   = RINFO(2); ! time step length
    GRAV = RINFO(3); !acceleration of gravity 
    RHOW = RINFO(4);   ! density of water 
	RHOA = RINFO(5); ! desity of air
    TI   = TIME;
    !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    ! - motion information
    !%%%%%%%%%%%%%%%%%%%%%%%%%%%%% 
    XG = STATE(1,IBODY) ! global positions of COG of of the body
    YG = STATE(2,IBODY)
    ZG = STATE(3,IBODY)
    VX = STATE(7,IBODY) ! global velocity of the body
    VY = STATE(8,IBODY)
    VZ = STATE(9,IBODY)
    VCX = CURVEL(1,1)   ! current velocity
    VCY = CURVEL(2,1)
    VCZ = CURVEL(3,1)
    !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    ! - data from matlab
    !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    OPEN(101, FILE = fileplace//'PNVLS.dat') 
    Read(101,*) SPNVL ! PANEL NORMAL VECTOR
    CLOSE(101)
    OPEN(102, FILE = fileplace//'A.dat') 
    Read(102,*) A   ! AREA OF LARGE PANEL
    CLOSE(102)
    OPEN(103, FILE = fileplace//'SNPB.dat') 
    Read(103,*) SNPBL!SUB NET PANEL (ACTING) POINT BOTTOM
    CLOSE(103)
    OPEN(104, FILE = fileplace//'SNPS.dat') 
    Read(104,*) SNPSL !SUB NET PANEL (ACTING) POINT BOTTOM
    CLOSE(104)
    OPEN(105, FILE = fileplace//'PNVLB.dat') 
    Read(105,*) BPNVL ! PANEL NORMAL VECTOR
    CLOSE(105)
    AS = A(1)
    AB = A(2)
    AS1 = AS/9
    AB1(1) = AB/4
    AB1(2) = AB1(1)*3
    SN = 0.161
    !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    ! - wave generation
    !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    !------------------------------------------!
    !----  transfer PNVL,SNPL to global  ----- ! S/B_PNVG, SNP_B/S_G
    !------------------------------------------! 
    DO I=1,12
        CALL TRANSLTG(GAMMA(1:9,IBODY),SPNVL(:,I),SPNVG(:,I))
        CALL TRANSLTG(GAMMA(1:9,IBODY),BPNVL(:,I),BPNVG(:,I))
        DO J = 1,9
            CALL COORDTRANSLTG(STATE(1:6,IBODY),SNPSL(:,J,I),SNPSG(:,J,I))
        END DO
        DO J = 1,2
            CALL COORDTRANSLTG(STATE(1:6,IBODY),SNPBL(:,J,I),SNPBG(:,J,I))
        END DO
    END DO
    !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    ! - wave generation
    !%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
    !------------------------------------------!
    !---- generate wave at each subpanel  ---- ! U/W_WAVESUB_S/B
    !------------------------------------------! 
    T = 15
    OMEGA = 2*PI/T
    K = OMEGA**2/GRAV
    ZETA0 = 2.5
    DO I=1,12
        DO J = 1,9
            X = SNPSG(1,J,I);
            Y = SNPSG(2,J,I);
            Z = SNPSG(3,J,I);    
            UWAVESUBS(J,I) = OMEGA*ZETA0*EXP(K*Z)*SIN(OMEGA*TI-K*X);
            WWAVESUBS(J,I) = OMEGA*ZETA0*EXP(K*Z)*COS(OMEGA*TI-K*X);
        END DO
        DO J = 1,2
            X = SNPBG(1,J,I);
            Y = SNPBG(2,J,I);
            Z = SNPBG(3,J,I);     
            UWAVESUBB(J,I) = OMEGA*ZETA0*EXP(K*Z)*SIN(OMEGA*TI-K*X);
            WWAVESUBB(J,I) = OMEGA*ZETA0*EXP(K*Z)*COS(OMEGA*TI-K*X);
        END DO
    END DO
    !-------------------------------------------------!
    !----------  wave force calculation  ------------ !
    !-------------------------------------------------!    
    DO I = 1,12
        DO J = 1,9
            VWX = UWAVESUBS(J,I)
            VWZ = WWAVESUBS(J,I)
    !----  find relative motion of subnet panel  ----- !
            RMV(1) = VWX+VCX-VX
            RMV(2) = 0-VY
            RMV(3) = VWZ+VCZ-VZ
            COSTHETAS(J,I) = dot_product(RMV,SPNVG(:,I))/NORM2(RMV)/NORM2(SPNVG(:,I))
    !----  find Cd of each net panel  ----- !
            CDS(J,I) = 0.04+(-0.04+0.33*SN+6.54*SN**2-4.88*SN**3)*ABS(COSTHETAS(J,I))
            FDS(J,I) = 0.5*RHOW*CDS(J,I)*NORM2(RMV)**2*AS1
            FDSX(J,I)= FDS(J,I)*RMV(1)/NORM2(RMV);
            FDSY(J,I)= FDS(J,I)*RMV(2)/NORM2(RMV);
            FDSZ(J,I)= FDS(J,I)*RMV(3)/NORM2(RMV);
            CALL CROSS_PRODUCT(SNPSG(:,J,I),[FDSX(J,I),FDSY(J,I),FDSZ(J,I)],MS(:,J,I))           
        END DO
        DO J = 1,2
            VWX = UWAVESUBB(J,I)
            VWZ = WWAVESUBB(J,I)
    !----  find relative motion of subnet panel  ----- !
            RMV(1) = VWX+VCX-VX
            RMV(2) = 0-VY
            RMV(3) = VWZ+VCZ-VZ
            COSTHETAB(J,I) = dot_product(RMV,BPNVG(:,I))/NORM2(RMV)/NORM2(BPNVG(:,I))
    !----  find Cd of each net panel  ----- !
            CDB(J,I) = 0.04+(-0.04+0.33*SN+6.54*SN**2-4.88*SN**3)*ABS(COSTHETAB(J,I))
            FDB(J,I) = 0.5*RHOW*CDB(J,I)*NORM2(RMV)**2*AB1(J)
            FDBX(J,I)= FDB(J,I)*RMV(1)/NORM2(RMV);
            FDBY(J,I)= FDB(J,I)*RMV(2)/NORM2(RMV);
            FDBZ(J,I)= FDB(J,I)*RMV(3)/NORM2(RMV);
            CALL CROSS_PRODUCT(SNPBG(:,J,I),[FDBX(J,I),FDBY(J,I),FDBZ(J,I)],MB(:,J,I)) 
        END DO  
        END DO
    STOR(1) = (SUM(FDSX)+SUM(FDBX))
    STOR(2) = (SUM(FDSY)+SUM(FDBY))
    STOR(3) = (SUM(FDSZ)+SUM(FDBZ))
    STOR(4) = (SUM(MS(1,:,:))+SUM(MB(1,:,:)))
    STOR(5) = (SUM(MS(2,:,:))+SUM(MB(2,:,:)))
    STOR(6) = (SUM(MS(3,:,:))+SUM(MB(3,:,:)))
    !STOR(1)=100
    END SUBROUTINE GFEXFO
    !-------------------------------------------------------------------------!
    !------SUBROUTINE 01: coordinate transformation from local to global------!
    !-------------------------------------------------------------------------!
    SUBROUTINE TRANSLTG(TMATRIX,XL,XG)
    DOUBLE PRECISION, INTENT(OUT)::XG(3)
    !$$$$$$ REAL, INTENT(IN)::TMATRIX(9),XL(3)
    DOUBLE PRECISION, INTENT(IN)::TMATRIX(9)
    DOUBLE PRECISION, INTENT(IN)::XL(3)
    XG(1) = TMATRIX(1)*XL(1)+TMATRIX(2)*XL(2)+TMATRIX(3)*XL(3)
    XG(2) = TMATRIX(4)*XL(1)+TMATRIX(5)*XL(2)+TMATRIX(6)*XL(3)
    XG(3) = TMATRIX(7)*XL(1)+TMATRIX(8)*XL(2)+TMATRIX(9)*XL(3)
    END SUBROUTINE TRANSLTG
!-------------------------------------------------------------!
!------ SUBROUTINE 02: cross product to calculate moment------!
!-------------------------------------------------------------!
    SUBROUTINE CROSS_PRODUCT(VECT1,VECT2,VECTOUT)
    DOUBLE PRECISION, INTENT(OUT)::VECTOUT(3)
    !$$$$$$ REAL, INTENT(IN)::TMATRIX(9),XL(3)
    DOUBLE PRECISION, INTENT(IN)::VECT1(3)
    DOUBLE PRECISION, INTENT(IN)::VECT2(3)
    vectout(1) = vect1(2) * vect2(3) - vect1(3) * vect2(2)
    vectout(2) = vect1(3) * vect2(1) - vect1(1) * vect2(3)
    vectout(3) = vect1(1) * vect2(2) - vect1(2) * vect2(1)    
    END SUBROUTINE CROSS_PRODUCT
    !---------------------------------------------------------------------!
    !------ SUBROUTINE 03: COORDINATES TRANSFER FROM LOCAL TO GLOBAL------!
    !---------------------------------------------------------------------!
    SUBROUTINE COORDTRANSLTG(BODYCOORD,VECT1,VECT2)
    DOUBLE PRECISION, INTENT(OUT)::VECT2(3)
    !$$$$$$ REAL, INTENT(IN)::TMATRIX(9),XL(3)
    DOUBLE PRECISION, INTENT(IN)::VECT1(3)
    DOUBLE PRECISION, INTENT(IN)::BODYCOORD(6)
    VECT2(1) = BODYCOORD(1)+VECT1(3)*BODYCOORD(5)-VECT1(2)*BODYCOORD(6);
    VECT2(2) = BODYCOORD(2)-VECT1(3)*BODYCOORD(4)+VECT1(1)*BODYCOORD(6);
    VECT2(3) = BODYCOORD(3)+VECT1(2)*BODYCOORD(4)-VECT1(1)*BODYCOORD(5);
    END SUBROUTINE COORDTRANSLTG