close all, clear all, clc
g       = 9.81;
rho_sw  = 1025;         %[kg/m^3]
depth   = 150;          %[m]
phi     = 49.1*pi/180;  %[deg], top angle
T       = 196.2*10^3;   %[N],top tension
Ty      = T*cos(phi);
Tz      = T*sin(phi);
%% chain
L_ch    = 1000;         %[m], length
D_ch    = 0.088*sqrt(2);%[m], diameter
A_ch    = pi*D_ch^2/4;  %[m^2], cross section area of chain
EA_ch   = 680.81e6;     %[N], axial stiffness
MBL_ch  = 7051.4e3;     %[N], minimum breaking load
rho_chsw= 147;          %[kg/m], density in water
rho_chai= rho_chsw+rho_sw*A_ch; %[kg/m], density in air
c_ch    = rho_chsw/rho_chai; % ratio of weight in water
rho_chai= rho_chai*g;   %[N/m]
E_ch    = EA_ch/A_ch;   %[Pa], Young's module
Y_ch    = MBL_ch/A_ch;  %[Pa], Yield strength
%% fibre
L_fi    = 100;          %[m], length
D_fi    = 0.16;         %[m], diameter
A_fi    = pi*D_fi^2/4;  %[m^2], cross section area of chain
EA_fi   = 235.44e6;     %[N], axial stiffness
MBL_fi  = 8122.7e3;     %[N], minimum breaking load
rho_fisw= 4;            %[kg/m], density in water
rho_fiai= rho_fisw+rho_sw*A_fi; %[kg/m], air density of fibre
c_fi    = rho_fisw/rho_fiai; % ratio of weight in water
rho_fiai= rho_fiai*g;   %[N/m]
E_fi    = EA_fi/A_fi;   %[Pa], Young's module
Y_fi    = MBL_fi/A_fi;  %[Pa], Yield strength
%% mooring shape
d       = 120;          %[m], water depth of mooring line
rho_m   = (rho_fisw*L_fi+rho_chsw*L_ch)/(L_ch+L_fi)*g; %[N/m], mean density of mooring line in water
d=400;
rho_m=1.92;
T=1000;
s       = sqrt(d*(2*T/rho_m-d));
X       = (T/rho_m-d)*log(s*T/rho_m/(T/rho_m-d));

